unit DataUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  AIOAIO, StdCtrls;

type
  TDataForm = class(TForm)
    DataList: TListBox;
  private
    { Private declarations }
  public
    iBoard: TBoardIndex;
    procedure DoRead;
    procedure DoClear;
    { Public declarations }
  end;

var
  DataForm: TDataForm;

implementation

{$R *.DFM}

const
	ResetOffset = $00;
	IRQEnableOffset = $01;
	DACOffset = $04;
	BaseClockOffset = $0C;
	DivisorOffset = $10;
	ADCRangeOffset = $18;
	AFLevelOffset = $20;
	ADCDepthOffset = $28;
	ADCDataOffset: array[0..1] of TUInt16 = ($30, $34);
	ADCStartStopOffset = $38;
	//ADCImmediateOffset = $3A;
	VersionOffset = $68;
	//ADCDataOffset: array[0..1] of TUInt32 = ($4000, $8000);
	dSequencer = $4;

	BaseADCCmd = $FCCE;
	ADCCmd_Go = $0001;
	ADCCmd_Continuous = $0020;
	ADCCmd_SingleEnded = $0800;

{ TDataForm }

procedure TDataForm.DoClear;
begin
  DataList.Items.Clear;
end;

procedure TDataForm.DoRead;
var
  Data: TUInt32;

begin
  Data := PIO_In32(iBoard, ADCDataOffset[0]);
  DataList.Items.Insert(0, IntToHex(Data, 8));
  
  Data := DataList.Items.Count;
  while Data > 256 do begin
    Dec(Data);
    DataList.Items.Delete(Data);
  end;
end;

end.
