unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    GroupBox1: TGroupBox;
    DeviceCombo: TComboBox;
    GroupBox2: TGroupBox;
    RegScroll: TScrollBox;
    GroupBox3: TGroupBox;
    RateEdit: TEdit;
    GroupBox4: TGroupBox;
    StartEdit: TEdit;
    Panel1: TPanel;
    TestButton: TButton;
    PollCheck: TCheckBox;
    PollTime: TTimer;
    procedure TestButtonClick(Sender: TObject);
    procedure RateEditChange(Sender: TObject);
    procedure StartEditChange(Sender: TObject);
    procedure PollCheckClick(Sender: TObject);
    procedure PollTimeTimer(Sender: TObject);
    procedure DeviceComboChange(Sender: TObject);
  protected
    procedure ControlCommandEditChange(Sender: TObject);
    procedure RegEditChange(Sender: TObject);
    { Private declarations }
  public
    procedure Init;
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses
  AIOAIO,
  DataUnit;

const
	ResetOffset = $00;
	IRQEnableOffset = $01;
	DACOffset = $04;
	BaseClockOffset = $0C;
	DivisorOffset = $10;
	ADCRangeOffset = $18;
	AFLevelOffset = $20;
	ADCDepthOffset = $28;
	ADCDataOffset: array[0..1] of TUInt16 = ($30, $34);
	ADCStartStopOffset = $38;
	//ADCImmediateOffset = $3A;
	VersionOffset = $68;
	//ADCDataOffset: array[0..1] of TUInt32 = ($4000, $8000);
	dSequencer = $4;

	BaseADCCmd = $FCCE;
	ADCCmd_Go = $0001;
	ADCCmd_Continuous = $0020;
	ADCCmd_SingleEnded = $0800;

{
type
  TUInt32 = LongWord; TPUInt32 = ^TUInt32;
  TAnsiChar = AnsiChar; TPAnsiChar = ^TAnsiChar;

  TWinErrCode = TUInt32;
  TBoardIndex = TUInt32;
  TSequencerIndex = TUInt32;

const
  BRD_GetHighestBoardIndex = 0;

function BRD_GetName(iBoard: TBoardIndex; iDeviceStrSize: TUInt32; pDeviceStr: PAnsiChar; poDeviceStrSize: TPUInt32): TWinErrCode;
begin
  poDeviceStrSize^ := 0;
  Result := ERROR_SUCCESS;
end;

function BRD_GetDeviceID(iBoard: TBoardIndex; pDeviceID: TPUInt32): TWinErrCode;
begin
  pDeviceID^ := $42;
  Result := ERROR_SUCCESS;
end;

function BRD_Reset(iBoard: TBoardIndex): TWinErrCode;
begin
  Result := ERROR_SUCCESS;
end;

function PIO_Out32(iBoard: TBoardIndex; Offset: TUInt32; Data: TUInt32): TWinErrCode;
begin
  Result := ERROR_SUCCESS;
end;

function ADC_SetRate(iBoard: TBoardIndex; iSequencer: TSequencerIndex; Hz: Double): TWinErrCode;
begin
  Result := ERROR_SUCCESS;
end;
}

{
function AnsiMessageBox(Text, Caption: AnsiString; uType: UINT): Integer;
begin
  Result := MessageBoxA(Application.Handle, PAnsiChar(Text), PAnsiChar(Caption), uType);
  Text := '';
  Caption := '';
end;
}

var
  RegData: array[0..55] of record
    RegNom: String;
    Reg32: LongWord;
    RegLabel: TLabel;
    RegEdit: TEdit;
  end =
  (
    ( RegNom: 'Control Command'; Reg32: $00000003 ),
    ( RegNom: 'Sensor Input Conversion Gain1'; Reg32: $39A3D70A ),
    ( RegNom: 'Sensor Input Conversion Offset 1'; Reg32: $00000000 ),
    ( RegNom: 'Sensor Input Conversion Gain2'; Reg32: $39A3D70A ),
    ( RegNom: 'Sensor Input Conversion Offset 2'; Reg32: $00000000 ),
    ( RegNom: 'Reference Input 1'; Reg32: $00307333 ),
    ( RegNom: 'Reference Input 2'; Reg32: $00318CCC ),
    ( RegNom: 'Reference Input Conversion Gain 1'; Reg32: $3CFA0000 ),
    ( RegNom: 'Reference Input Conversion Offset 1'; Reg32: $447A0000 ),
    ( RegNom: 'Reference Input Conversion Gain 2'; Reg32: $3CFA0000 ),
    ( RegNom: 'Reference Input Conversion Offset 2'; Reg32: $447A0000 ),
    ( RegNom: 'Sensor Filter Coefficient a1'; Reg32: $3E8FD220 ),
    ( RegNom: 'Sensor Filter Coefficient a2'; Reg32: $BE3DF3B6 ),
    ( RegNom: 'Sensor Filter Coefficient b0'; Reg32: $3E6786C2 ),
    ( RegNom: 'Sensor Filter Coefficient b1'; Reg32: $3EE793DE ),
    ( RegNom: 'Sensor Filter Coefficient b2'; Reg32: $3E6786C2 ),
    ( RegNom: 'Linearization 1 Polynomial a0'; Reg32: $447A0000 ),
    ( RegNom: 'Linearization 1 Polynomial a1'; Reg32: $42C80000 ),
    ( RegNom: 'Linearization 1 Polynomial a2'; Reg32: $00000000 ),
    ( RegNom: 'Linearization 1 Polynomial a3'; Reg32: $00000000 ),
    ( RegNom: 'Linearization 2 Polynomial a0'; Reg32: $447A0000 ),
    ( RegNom: 'Linearization 2 Polynomial a1'; Reg32: $42C80000 ),
    ( RegNom: 'Linearization 2 Polynomial a2'; Reg32: $00000000 ),
    ( RegNom: 'Linearization 2 Polynomial a3'; Reg32: $00000000 ),
    ( RegNom: 'Rotation Matrix a11'; Reg32: $3F800000 ),
    ( RegNom: 'Rotation Matrix a12'; Reg32: $00000000 ),
    ( RegNom: 'Rotation Matrix a21'; Reg32: $00000000 ),
    ( RegNom: 'Rotation Matrix a22'; Reg32: $3F800000 ),
    ( RegNom: 'PID Control Kf1'; Reg32: $3C23D70A ),
    ( RegNom: 'PID Control Kp1'; Reg32: $3B83126F ),
    ( RegNom: 'PID Control Ki1'; Reg32: $398D8EC9 ),
    ( RegNom: 'PID Control Kd1'; Reg32: $3C23D70A ),
    ( RegNom: 'PID Control Kf2'; Reg32: $3C23D70A ),
    ( RegNom: 'PID Control Kp2'; Reg32: $3B83126F ),
    ( RegNom: 'PID Control Ki2'; Reg32: $398D8EC9 ),
    ( RegNom: 'PID Control Kd2'; Reg32: $3C23D70A ),
    ( RegNom: 'PID Control SumError1'; Reg32: $49742400 ),
    ( RegNom: 'PID Control SumError2'; Reg32: $49742400 ),
    ( RegNom: 'PID Derivative Filter Coefficient a1'; Reg32: $3F7AEE63 ),
    ( RegNom: 'PID Derivative Filter Coefficient b0'; Reg32: $3E4AC5B4 ),
    ( RegNom: 'PID Derivative Filter Coefficient b1'; Reg32: $BE4AC5B4 ),
    ( RegNom: 'Notch Filter Coefficient a1'; Reg32: $405B381D ),
    ( RegNom: 'Notch Filter Coefficient a2'; Reg32: $C09CB9F5 ),
    ( RegNom: 'Notch Filter Coefficient a3'; Reg32: $40575C29 ),
    ( RegNom: 'Notch Filter Coefficient a4'; Reg32: $BF7710CB ),
    ( RegNom: 'Notch Filter Coefficient b0'; Reg32: $3F7B7E91 ),
    ( RegNom: 'Notch Filter Coefficient b1'; Reg32: $C05947AE ),
    ( RegNom: 'Notch Filter Coefficient b2'; Reg32: $409CBE0E ),
    ( RegNom: 'Notch Filter Coefficient b3'; Reg32: $C05947AE ),
    ( RegNom: 'Notch Filter Coefficient b4'; Reg32: $3F7B7E91 ),
    ( RegNom: 'Notch Output Conversion Gain1'; Reg32: $454CCC00 ),
    ( RegNom: 'Notch Output Conversion Offset 1'; Reg32: $00000000 ),
    ( RegNom: 'Notch Output Conversion Gain2'; Reg32: $454CCC00 ),
    ( RegNom: 'Notch Output Conversion Offset 2'; Reg32: $00000000 ),
    ( RegNom: 'PID MaxControl'; Reg32: $41200000 ),
    ( RegNom: 'PID MinControl'; Reg32: $C1200000 )
  );

function StripFloat(S: String): String;
begin
  while S[1] = '0' do S := Copy(S, 2, MAXINT);
  while S[Length(S)] = '0' do S := Copy(S, 1, Length(S)-1);
  if S[Length(S)] = '.' then S := Copy(S, 1, Length(S)-1);
  if S = '' then S := '0';
  Result := S;
end;

{ TMainForm }

procedure TMainForm.ControlCommandEditChange(Sender: TObject);
var
  iReg: Integer;
  F32: LongWord;

begin
  iReg := (Sender as TComponent).Tag;

  with RegData[iReg] do try
    F32 := StrToInt('$' + RegEdit.Text);
    RegEdit.Color := clWindow;
    RegEdit.ParentFont := True;

    Reg32 := F32;
  except
    RegEdit.Color := $000080;
    RegEdit.Font.Color := $8080FF;
  end;
end;

procedure TMainForm.DeviceComboChange(Sender: TObject);
begin
  DataForm.DoClear;
  DataForm.iBoard := DeviceCombo.ItemIndex;
end;

procedure TMainForm.Init;
const
  LabelHt = 16;
  EditHt = 24;

var
  I: Integer;
  DeviceStr: AnsiString;
  DeviceStrSize: TUInt32;
  Status: TWinErrCode;
  DeviceID: TUInt32;
  F: Single;
  F32: LongWord absolute F;

begin
  //QueryPerformanceFrequency(TicksPerSec);
  IsMultiThread := True;

  for I := 0 to High(RegData) do with RegData[I] do begin
    F32 := Reg32;
  
    RegLabel := TLabel.Create(Self);
    RegLabel.AutoSize := False;
    RegLabel.Caption := RegNom;
    RegLabel.Layout := tlBottom;
    RegLabel.SetBounds(0, (LabelHt + EditHt)*I, 256, LabelHt);
    RegLabel.Align := alTop;
    RegLabel.Parent := RegScroll;

    RegEdit := TEdit.Create(Self);
    RegEdit.Tag := I;
    RegEdit.AutoSize := False;
    if I = 0 then
      RegEdit.Text := IntToHex(F32, 1)
    else
      RegEdit.Text := StripFloat(FloatToStrF(F, ffFixed, 7, 10))
    ;
    RegEdit.SetBounds(0, (LabelHt + EditHt)*I + LabelHt, 256, EditHt);
    RegEdit.Align := alTop;
    RegEdit.Parent := RegScroll;
    if I = 0 then
      RegEdit.OnChange := ControlCommandEditChange
    else
      RegEdit.OnChange := RegEditChange
    ;

    RegLabel.FocusControl := RegEdit;
  end;
  RateEdit.Align := alTop;
  StartEdit.Align := alTop;

  DeviceCombo.Align := alTop;
  DeviceCombo.Items.Clear;
  for I := 0 to BRD_GetHighestBoardIndex do begin
    DeviceStrSize := MAX_PATH;
    DeviceStr := StringOfChar(AnsiChar(#0), DeviceStrSize);
    Status := BRD_GetName(I, DeviceStrSize, TPAnsiChar(DeviceStr), @DeviceStrSize);
    if Status <> ERROR_SUCCESS then
      DeviceStr := '<Error ' + AnsiString(IntToStr(Status)) + ' from BRD_GetName>'
    else
      SetLength(DeviceStr, DeviceStrSize)
    ;
    BRD_GetDeviceID(I, @DeviceID);
    DeviceCombo.Items.Add('[' + IntToStr(I) + '] ' + String(DeviceStr) + ' - DeviceID: ' + IntToHex(DeviceID, 4));
  end;
  if DeviceCombo.Items.Count <> 0 then begin
    DeviceCombo.ItemIndex := 0;
    DeviceComboChange(DeviceCombo);
  end;
end;

procedure TMainForm.PollCheckClick(Sender: TObject);
begin
  PollTime.Enabled := PollCheck.Checked;
end;

procedure TMainForm.PollTimeTimer(Sender: TObject);
var
  Depth, I: LongWord;
  iBoard: TBoardIndex;

begin
  if not DataForm.Visible then DataForm.Show;

  iBoard := DeviceCombo.ItemIndex;
  
  Depth := PIO_In32(iBoard, ADCDepthOffset);
  if Depth = $FFFFFFFF then Exit;
  if Depth = $AA55AA55 then Exit;

  for I := Depth downto 1 do begin
    DataForm.DoRead;
    //DataForm.DoRead;
  end;
end;

procedure TMainForm.RateEditChange(Sender: TObject);
begin
  try
    StrToFloat(RateEdit.Text);
    RateEdit.Color := clWindow;
    RateEdit.ParentFont := True;
  except
    RateEdit.Color := $000080;
    RateEdit.Font.Color := $8080FF;
  end;
end;

procedure TMainForm.RegEditChange(Sender: TObject);
var
  iReg: Integer;
  F: Single;
  F32: LongWord absolute F;

begin
  iReg := (Sender as TComponent).Tag;

  with RegData[iReg] do try
    F := StrToFloat(RegEdit.Text);
    RegEdit.Color := clWindow;
    RegEdit.ParentFont := True;

    Reg32 := F32;
  except
    RegEdit.Color := $000080;
    RegEdit.Font.Color := $8080FF;
  end;
end;

procedure TMainForm.StartEditChange(Sender: TObject);
begin
  try
    StrToInt('$' + StartEdit.Text);
    StartEdit.Color := clWindow;
    StartEdit.ParentFont := True;
  except
    StartEdit.Color := $000080;
    StartEdit.Font.Color := $8080FF;
  end;
end;

procedure TMainForm.TestButtonClick(Sender: TObject);
var
  iBoard: TBoardIndex;
  iReg: Integer;
  BadCt: Integer;
  ErrMsg: String;
  Hz: Double;
  StartCmd: LongWord;

begin
  BadCt := 0;
  if not RateEdit.ParentFont then Inc(BadCt);
  if not StartEdit.ParentFont then Inc(BadCt);
  for iReg := 0 to High(RegData) do
    if not RegData[iReg].RegEdit.ParentFont then
      Inc(BadCt)
  ;
  if BadCt <> 0 then begin
    if BadCt = 1 then
      ErrMsg := '1 entry is'
    else
      ErrMsg := IntToStr(BadCt) + ' entries are'
    ;
    ErrMsg := ErrMsg + ' invalid(red). Please correct and try again.';
    Application.MessageBox(@ErrMsg[1], 'Invalid Entry', MB_ICONEXCLAMATION);
  end;

  iBoard := DeviceCombo.ItemIndex;
  Hz := StrToFloat(RateEdit.Text);
  StartCmd := StrToInt('$' + StartEdit.Text);

  BRD_Reset(iBoard);

  Sleep(1);

  BRD_Reset(iBoard);

  Sleep(1);

  for iReg := 0 to High(RegData) do
    PIO_Out32(iBoard, $80 + 4*iReg, RegData[iReg].Reg32)
  ;
  ADC_SetRate(iBoard, 0, Hz);

  PIO_Out32(iBoard, $38, StartCmd);

  PollCheck.Checked := True;
end;

end.
